"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const prelude_js_1 = require("./prelude.js");
const blacken = (_) => {
    switch (true) {
        // blacken (T R (T R a x b) y c) = T B (T R a x b) y c
        case _?.c === prelude_js_1.R && _.l?.c === prelude_js_1.R: {
            const { l: { l: a, v: x, n: i, r: b }, v: y, n: j, r: c } = _;
            return (0, prelude_js_1.mk)(prelude_js_1.B, (0, prelude_js_1.mk)(prelude_js_1.R, a, x, i, b), y, j, c);
        }
        // blacken (T R a x (T R b y c)) = T B a x (T R b y c)
        case _?.c === prelude_js_1.R && _.r?.c === prelude_js_1.R: {
            const { l: a, v: x, n: i, r: { l: b, v: y, n: j, r: c } } = _;
            return (0, prelude_js_1.mk)(prelude_js_1.B, a, x, i, (0, prelude_js_1.mk)(prelude_js_1.R, b, y, j, c));
        }
        // blacken t = t
        default:
            return _;
    }
};
exports.default = blacken;
//# sourceMappingURL=blacken.js.map